URL helpers must be used in mailers
07/27/2016 03:23 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: E-Mail
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3677
Description

#8797 changed mailers from using *_url helpers to *_path, and relied on Roadie's URL rewriting to change them to full URLs. This
works reliably and avoids needing to repeat URL options, but it throws deprecation warnings and will not work in Rails 5.

Running host_mailer_test generates warnings such as:

DEPRECATION WARNING: The method “host_path® cannot be used here as a full URL is required. Use "ho
st_url® instead. (called from app_views_host_mailer

_link_to_host_html_erb_ 4138992061028702271_130918480 at /home/dcleal/code/foreman/foreman/app/vie

ws/host_mailer/_link_to_host.html.erb:2)

The change could probably be mostly reverted, and default_url_options used in the mailer to avoid the repetition of URL options.

Related issues:
Related to Foreman - Refactor #8797: Separate style from the HTML in emails. Closed 12/28/2014
Related to Foreman - Refactor #14006: Mailers calling *_path with :only_path ... Closed 03/02/2016

Associated revisions

Revision a9fe14bf - 07/27/2016 05:41 AM - Dominic Cleal

fixes #15847 - change mailer helpers from paths to URLs

Use of path helpers in mailers (with Roadie to rewrite to URLs) is
deprecated in Rails 4 and removed in Rails 5, so prefer URL helpers. To

replace URL rewriting and reduce duplication, default_url_options is now
configured. Roadie URL rewriting may still be used for assets.

History

#1 - 07/27/2016 03:23 AM - Dominic Cleal
- Related to Refactor #8797: Separate style from the HTML in emails. added

#2 - 07/27/2016 03:23 AM - Dominic Cleal
- Related to Refactor #14006: Mailers calling *_path with :only_path => false should use _url helpers added

#3 - 07/27/2016 03:40 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3677 added

#4 - 07/27/2016 06:02 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a9fe14bf40e7{70862c91deb15327e818231e85¢.
#5 - 07/27/2016 06:28 AM - Dominic Cleal

- translation missing: en.field_release set to 160
